## shaarli 0.12.0+dfsg

=== Makefile ===
# The personal, minimalist, super-fast, database free, bookmarking service.
# Makefile for PHP code analysis & testing, documentation and release generation

BIN = vendor/bin

all: check_permissions test

##
# Docker test adapter
#
# Shaarli sources and vendored libraries are copied from a shared volume
# to a user-owned directory to enable running tests as a non-root user.
##
docker_%:
	rsync -az /shaarli/ ~/shaarli/
	cd ~/shaarli && make $*

##
# PHP_CodeSniffer
# Detects PHP syntax errors
# Documentation (usage, output formatting):
# - http://pear.php.net/manual/en/package.php.php-codesniffer.usage.php
# - http://pear.php.net/manual/en/package.php.php-codesniffer.reporting.php
##
PHPCS := $(BIN)/phpcs

code_sniffer:
	@$(PHPCS)

### - errors filtered by coding standard: PEAR, PSR1, PSR2, Zend...
PHPCS_%:
	@$(PHPCS) --report-full --report-width=200 --standard=$*

### - errors by Git author
code_sniffer_blame:
	@$(PHPCS) --report-gitblame

### - all errors/warnings
code_sniffer_full:
	@$(PHPCS) --report-full --report-width=200

### - errors grouped by kind
code_sniffer_source:
	@$(PHPCS) --report-source || exit 0

##
# Checks source file & script permissions
##
check_permissions:
	@echo "----------------------"
	@echo "Check file permissions"
	@echo "----------------------"
	@for file in `git ls-files | grep -v docker`; do \
		if [ -x $$file ]; then \
			errors=true; \
			echo "$${file} is executable"; \
		fi \
	done; [ -z $$errors ] || false

##
# PHPUnit
# Runs unitary and functional tests
# Generates an HTML coverage report if Xdebug is enabled
#
# See phpunit.xml for configuration
# https://phpunit.de/manual/current/en/appendixes.configuration.html
##
test: translate
	@echo "-------"
	@echo "PHPUNIT"
	@echo "-------"
	@mkdir -p sandbox coverage
	@$(BIN)/phpunit --coverage-php coverage/main.cov --bootstrap tests/bootstrap.php --testsuite unit-tests

locale_test_%:
	@UT_LOCALE=$*.utf8 \
		$(BIN)/phpunit \
		--coverage-php coverage/$(firstword $(subst _, ,$*)).cov \
		--bootstrap tests/languages/bootstrap.php \
		--testsuite language-$(firstword $(subst _, ,$*))

all_tests: test locale_test_de_DE locale_test_en_US locale_test_fr_FR
	@# --The current version is not compatible with PHP 7.2
	@#$(BIN)/phpcov merge --html coverage coverage
	@# --text doesn't work with phpunit 4.* (v5 requires PHP 5.6)
	@#$(BIN)/phpcov merge --text coverage/txt coverage

### download 3rd-party PHP libraries, including dev dependencies
composer_dependencies_dev: clean
	composer install --prefer-dist

##
# Custom release archive generation
#
# For each tagged revision, GitHub provides tar and zip archives that correspond
# to the output of git-archive
#
# These targets produce similar archives, featuring 3rd-party dependencies
# to ease deployment on shared hosting.
##
ARCHIVE_VERSION := shaarli-$$(git describe)-full
ARCHIVE_PREFIX=Shaarli/

release_archive: release_tar release_zip

### download 3rd-party PHP libraries
composer_dependencies: clean
	composer install --no-dev --prefer-dist
	find vendor/ -name ".git" -type d -exec rm -rf {} +

### download 3rd-party frontend libraries
frontend_dependencies:
	yarn install

### Build frontend dependencies
build_frontend: frontend_dependencies
	yarn run build

### generate a release tarball and include 3rd-party dependencies and translations
release_tar: composer_dependencies htmldoc translate build_frontend
	git archive --prefix=$(ARCHIVE_PREFIX) -o $(ARCHIVE_VERSION).tar HEAD
	tar rvf $(ARCHIVE_VERSION).tar --transform "s|^vendor|$(ARCHIVE_PREFIX)vendor|" vendor/
	tar rvf $(ARCHIVE_VERSION).tar --transform "s|^doc/html|$(ARCHIVE_PREFIX)doc/html|" doc/html/
	tar rvf $(ARCHIVE_VERSION).tar --transform "s|^tpl|$(ARCHIVE_PREFIX)tpl|" tpl/
	gzip $(ARCHIVE_VERSION).tar

### generate a release zip and include 3rd-party dependencies and translations
release_zip: composer_dependencies htmldoc translate build_frontend
	git archive --prefix=$(ARCHIVE_PREFIX) -o $(ARCHIVE_VERSION).zip -9 HEAD
	mkdir -p $(ARCHIVE_PREFIX)/doc
	mkdir -p $(ARCHIVE_PREFIX)/vendor
	rsync -a doc/html/ $(ARCHIVE_PREFIX)doc/html/
	zip -r $(ARCHIVE_VERSION).zip $(ARCHIVE_PREFIX)doc/
	rsync -a vendor/ $(ARCHIVE_PREFIX)vendor/
	zip -r $(ARCHIVE_VERSION).zip $(ARCHIVE_PREFIX)vendor/
	rsync -a tpl/ $(ARCHIVE_PREFIX)tpl/
	zip -r $(ARCHIVE_VERSION).zip $(ARCHIVE_PREFIX)tpl/
	rm -rf $(ARCHIVE_PREFIX)

##
# Targets for repository and documentation maintenance
##

### remove all unversioned files
clean:
	@git clean -df
	@rm -rf sandbox

### generate the AUTHORS file from Git commit information
authors:
	@cp .github/mailmap .mailmap
	@git shortlog -sne > AUTHORS
	@rm .mailmap

### generate phpDocumentor documentation
phpdoc: clean
	@docker run --rm -v $(PWD):/data -u `id -u`:`id -g` phpdoc/phpdoc

### generate HTML documentation from Markdown pages with MkDocs
htmldoc:
	python3 -m venv venv/
	bash -c 'source venv/bin/activate; \
	pip install wheel; \
	pip install mkdocs; \
	mkdocs build --clean'
	find doc/html/ -type f -exec chmod a-x '{}' \;
	rm -r venv


### Generate Shaarli's translation compiled file (.mo)
translate:
	@find inc/languages/ -name shaarli.po -execdir msgfmt shaarli.po -o shaarli.mo \;

### Run ESLint check against Shaarli's JS files
eslint:
	@yarn run eslint -c .dev/.eslintrc.js assets/vintage/js/
	@yarn run eslint -c .dev/.eslintrc.js assets/default/js/

### Run CSSLint check against Shaarli's SCSS files
sasslint:
	@yarn run stylelint --config .dev/.stylelintrc.js 'assets/default/scss/*.scss'

## shaarli 0.0.41~beta~dfsg2

=== debian/changelog ===
shaarli (0.0.41~beta~dfsg2-4) unstable; urgency=low

  * Fix multiple XSS in index.php (CVE-2013-7351) (Closes: #743252)
      This is already fixed upstream:
      https://github.com/sebsauvage/Shaarli/issues/134
  * Update Standards-Version to 3.9.5

 -- Emilien Klein <emilien+debian@klein.st>  Tue, 01 Apr 2014 21:26:06 +0200

shaarli (0.0.41~beta~dfsg2-3) unstable; urgency=low

  * Remove check to see if own directory is readable (check was only
    partially removed)
  * Solve various Lintian warnings and info:
    - field-name-typo-in-dep5-copyright
    - vcs-field-not-canonical
    - unused-license-paragraph-in-dep5-copyright

 -- Emilien Klein <emilien+debian@klein.st>  Mon, 07 Oct 2013 22:12:34 +0200

shaarli (0.0.41~beta~dfsg2-2) unstable; urgency=low

  * improved the file d/copyright, thanks to Luca Flavigna's remarks

 -- Georges Khaznadar <georgesk@debian.org>  Sat, 01 Jun 2013 16:53:09 +0200

shaarli (0.0.41~beta~dfsg2-1) unstable; urgency=low

  [ Emilien Klein ]
  * Initial release (Closes: #654814 and #709644)

  [ Georges Khaznadar ]
  * Updated Maintainer: and Uploaders: fields in d/control

 -- Emilien Klein <emilien+debian@klein.st>  Sun, 26 May 2013 22:36:57 +0200

=== debian/control ===
Source: shaarli
Section: web
Priority: optional
Maintainer: Emilien Klein <emilien+debian@klein.st>
Uploaders: Georges Khaznadar <georgesk@debian.org>
Build-Depends: debhelper (>= 8.0.0)
Standards-Version: 3.9.5
Homepage: http://sebsauvage.net/wiki/doku.php?id=php:shaarli
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/shaarli.git
Vcs-Git: git://anonscm.debian.org/collab-maint/shaarli.git

Package: shaarli
Architecture: all
Depends: libapache2-mod-php5 | libapache2-mod-php5filter | php5-cgi | php5-fpm | php5,
         php5-gd,
         libjs-jquery,
         libjs-jquery-ui,
         libjs-jquery-lazyload,
         raintpl,
         ${misc:Depends}
Recommends: apache2 | httpd
Description: Personal, minimalist, super-fast and no-database Delicious clone
 Saving simple links should not be a complicated heavy thing. Shaarli
 is simple, but it does the job and does it well. And your data is not
 hosted on a foreign server, but on your server.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

override_dh_fixperms:
	dh_fixperms
	# The files in the released tarball are set to executable (source is
	# released from Windows)
	chmod 644 debian/shaarli/usr/share/shaarli/images/*
	chmod 644 debian/shaarli/usr/share/shaarli/inc/*
	chmod 644 debian/shaarli/usr/share/shaarli/tpl/*
	chmod 644 debian/shaarli/usr/share/shaarli/index.php

%:
	dh $@

=== debian/watch ===
version=3

opts=dversionmangle=s/~beta~dfsg\d+$/beta/ \
  http://sebsauvage.net/wiki/doku.php?id=php:shaarli http://sebsauvage.net/files/shaarli_(.*)\.zip

## shaarli 0.0.42~beta~dfsg1

=== debian/changelog ===
shaarli (0.0.42~beta~dfsg1-2ubuntu1) xenial; urgency=medium

  * Update to PHP7.0 dependencies (LP: #1565159).

 -- Nishanth Aravamudan <nish.aravamudan@canonical.com>  Fri, 01 Apr 2016 17:04:41 -0700

shaarli (0.0.42~beta~dfsg1-2) unstable; urgency=low

  * Fix permissions on cache and data folders (Closes: #773039)
  * Fix previous changelog entry, indicating upstream change

 -- Emilien Klein <emilien+debian@klein.st>  Sat, 13 Dec 2014 16:40:35 +0100

shaarli (0.0.42~beta~dfsg1-1) unstable; urgency=low

  * New upstream version
  * d/control and d/watch: The upstream source was changed from Seb Sauvage's
      inactive repository [0] to the community-maintained repository [1].
      [0] https://github.com/sebsauvage/Shaarli
      [1] https://github.com/shaarli/Shaarli
  * d/control:
      - Depend on javascript-common to serve the JavaScript libraries
      - Update Standards-Version to 3.9.6
  * d/copyright:
      - Mention the licenses of the Javascript libraries
      - Rename BSD to BSD-3-clause
  * d/patches/remove-qr.js-library.patch: Remove the JavaScript code using
      the qr.js library, based on concerns on potential license issues.
      See https://github.com/neocotic/qr.js/issues/23 for detail.
  * d/patches/fix-bug-743252-CVE-2013-7351: Remove patch for #743252, as it is
      included upstream
  * d/patches/javascript-libraries.patch: Update due to upstream changes where
      JavaScript libraries are used

 -- Emilien Klein <emilien+debian@klein.st>  Sun, 26 Oct 2014 23:21:49 +0100

shaarli (0.0.41~beta~dfsg2-5) unstable; urgency=low

  [ Emilien Klein ]
  * Move Apache config file from /etc/shaarli/apache.conf to
    /etc/apache2/conf-available/shaarli.conf

  [ Georges Khaznadar ]
  * added a build-dependency on apache2-dev
  * added "--with apache2" in d/rules; Closes: #743336

 -- Emilien Klein <emilien+debian@klein.st>  Wed, 23 Jul 2014 20:51:16 +0200

=== debian/control ===
Source: shaarli
Section: web
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Emilien Klein <emilien+debian@klein.st>
Uploaders: Georges Khaznadar <georgesk@debian.org>
Build-Depends: debhelper (>= 8.0.0), apache2-dev
Standards-Version: 3.9.6
Homepage: https://github.com/shaarli/Shaarli
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/shaarli.git
Vcs-Git: git://anonscm.debian.org/collab-maint/shaarli.git

Package: shaarli
Architecture: all
Depends: libapache2-mod-php | libapache2-mod-phpfilter | php-cgi | php-fpm | php,
         php-gd,
         javascript-common,
         libjs-jquery,
         libjs-jquery-ui,
         libjs-jquery-lazyload,
         raintpl,
         ${misc:Depends}
Recommends: apache2 | httpd, ${misc:Recommends}
Description: Personal, minimalist, super-fast and no-database Delicious clone
 Saving simple links should not be a complicated heavy thing. Shaarli
 is simple, but it does the job and does it well. And your data is not
 hosted on a foreign server, but on your server.

=== debian/rules ===
--- 
+++ 
@@ -17,6 +17,11 @@
 	chmod 644 debian/shaarli/usr/share/shaarli/inc/*
 	chmod 644 debian/shaarli/usr/share/shaarli/tpl/*
 	chmod 644 debian/shaarli/usr/share/shaarli/index.php
+	# Make the web server user the owner of the cache and data directories
+	chown www-data:www-data debian/shaarli/var/lib/shaarli/data
+	chown www-data:www-data debian/shaarli/var/cache/shaarli/cache
+	chown www-data:www-data debian/shaarli/var/cache/shaarli/pagecache
+	chown www-data:www-data debian/shaarli/var/cache/shaarli/tmp
 
 %:
-	dh $@ 
+	dh $@ --with apache2

=== debian/watch ===
version=3

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/shaarli-$1\.tar\.gz/,dversionmangle=s/~beta~dfsg\d+$/beta/ \
  https://github.com/shaarli/Shaarli/tags .*/v?(\d\S*)\.tar\.gz

## shaarli 0.12.0+dfsg

=== debian/changelog ===
shaarli (0.12.0+dfsg-3) unstable; urgency=low

  * Compile scss and add build dependencies
  * Use purecss from sass-stylesheets-purecss
  * Use vendored pure-extras
  * Use installed fork-awesome fonts (Closes: #980134)

 -- James Valleroy <jvalleroy@mailbox.org>  Fri, 03 Sep 2021 19:21:13 -0400

shaarli (0.12.0+dfsg-2) unstable; urgency=low

  * Upload to unstable
  * Fix tests during package build
  * Run webpack during build but ignore errors
  * webpack: Use uglifyjs instead of terser
  * testHumanBytes: Skip 2 GiB test on 32-bit systems
  * Set standards version to 4.5.1

 -- James Valleroy <jvalleroy@mailbox.org>  Wed, 13 Jan 2021 20:48:01 -0500

shaarli (0.12.0+dfsg-1) experimental; urgency=medium

  * Import new upstream release v0.12.0
  * d/control: Clarify short description
  * d/README.source: Update instructions for new upstream release
  * d/patches: Update patches to apply to 0.12.0 upstream
  * Remove obsolete lintian override
  * d/install: Install .htaccess
  * Remove LimitExcept from top level .htaccess
  * Rename patches to have consecutive order
  * d/control: Add php-ldap dependency
  * Update skipped tests under root user

 -- James Valleroy <jvalleroy@mailbox.org>  Thu, 12 Nov 2020 09:13:48 -0500

shaarli (0.11.1+dfsg-1) experimental; urgency=medium

  * Initial release (Closes: #864559).

 -- James Valleroy <jvalleroy@mailbox.org>  Sun, 11 Oct 2020 09:23:56 -0400

=== debian/control ===
Source: shaarli
Section: web
Priority: optional
Maintainer: Debian PHP PEAR Maintainers <pkg-php-pear@lists.alioth.debian.org>
Uploaders: James Valleroy <jvalleroy@mailbox.org>
Build-Depends: apache2-dev,
               debhelper-compat (= 13),
               fonts-fork-awesome,
               gettext,
               libjs-awesomplete,
               libjs-blazy,
               mkdocs,
               node-babel-loader,
               node-css-loader,
               node-file-loader,
               node-mini-css-extract-plugin,
               node-uglifyjs-webpack-plugin,
               php-arthurhoaro-web-thumbnailer,
               php-curl,
               php-gd,
               php-intl,
               php-ldap,
               php-mbstring,
               php-netscape-bookmark-parser,
               php-oscarotero-gettext,
               php-parsedown,
               php-pubsubhubbub-publisher,
               php-slim,
               phpab,
               phpunit,
               pkg-php-tools,
               ruby-sass,
               sass-stylesheets-purecss,
               webpack
Standards-Version: 4.5.1
Homepage: https://github.com/shaarli/Shaarli
Vcs-Browser: https://salsa.debian.org/php-team/pear/shaarli
Vcs-Git: https://salsa.debian.org/php-team/pear/shaarli.git
Rules-Requires-Root: no

Package: shaarli
Architecture: all
Depends: gettext,
         javascript-common,
         libapache2-mod-php | php-cgi | php-fpm | php,
         libjs-jquery,
         libjs-jquery-lazyload,
         libjs-jquery-ui,
         php-curl,
         php-gd,
         php-intl,
         php-ldap,
         php-mbstring,
         ${misc:Depends},
         ${phpcomposer:Debian-require}
Recommends: apache2 | httpd, ${misc:Recommends}
Description: Personal, minimalist, super-fast and no-database bookmarking service
 Saving simple links should not be a complicated heavy thing. Shaarli
 is simple, but it does the job and does it well. And your data is not
 hosted on a foreign server, but on your server.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE=1

%:
	dh $@ --with apache2 --with phpcomposer

override_dh_auto_build:
	phpab \
		--output autoload.php \
		--template debian/autoload.php.tpl \
		*.php application plugins
	mkdir --parents vendor
	phpab \
		--output vendor/autoload.php \
		--template debian/autoload.php.tpl \
		*.php application tests plugins
	make translate
	make htmldoc
	mkdir --parents assets/default/css
	sass assets/default/scss/shaarli.scss > assets/default/css/shaarli.css
	# Ignore errors due to missing dependencies.
	webpack || true

## shaarli 0.12.1%2Bdfsg

=== debian/changelog ===
shaarli (0.12.1+dfsg-8+deb12u2) bookworm-security; urgency=medium

  * Add patch to fix stored XSS via tag suggestions
    (Closes: #1126554, CVE-2026-24476)

 -- James Valleroy <jvalleroy@mailbox.org>  Fri, 06 Feb 2026 10:19:00 -0500

shaarli (0.12.1+dfsg-8+deb12u1) bookworm; urgency=medium

  * Add patch to fix CVE-2025-55291 (Closes: #1111589)

 -- James Valleroy <jvalleroy@mailbox.org>  Sat, 30 Aug 2025 09:48:22 -0400

shaarli (0.12.1+dfsg-8) unstable; urgency=medium

  * Allow AuthConfig in .htaccess
  * Create link for cache folder (Closes: #1029921)

 -- James Valleroy <jvalleroy@mailbox.org>  Sun, 29 Jan 2023 07:36:49 -0500

shaarli (0.12.1+dfsg-7) unstable; urgency=medium

  * Add copyright info for pure-extras
  * webpack: css-loader: Disable url() resolving
  * Add symlinks to font files (Closes: #1027401)

 -- James Valleroy <jvalleroy@mailbox.org>  Sat, 14 Jan 2023 20:42:54 -0500

shaarli (0.12.1+dfsg-6) unstable; urgency=medium

  * Cherry-pick date view fix from upstream

 -- James Valleroy <jvalleroy@mailbox.org>  Mon, 31 Oct 2022 21:59:59 -0400

shaarli (0.12.1+dfsg-5) unstable; urgency=medium

  * Install docs
  * Limit output of apache-test

 -- James Valleroy <jvalleroy@mailbox.org>  Sun, 16 Oct 2022 09:07:31 -0400

shaarli (0.12.1+dfsg-4) unstable; urgency=medium

  * d/tests: Add apache test
  * Update debian/* copyright year

 -- James Valleroy <jvalleroy@mailbox.org>  Wed, 05 Oct 2022 06:50:31 -0400

shaarli (0.12.1+dfsg-3) unstable; urgency=medium

  * mkdocs: Change pages to nav
  * Drop patch 0010-webpack-Use-uglifyjs-instead-of-terser (Closes: #1011447)
  * webpack: Resolve from system install paths
  * Set standards version to 4.6.1

 -- James Valleroy <jvalleroy@mailbox.org>  Fri, 27 May 2022 09:12:44 -0400

shaarli (0.12.1+dfsg-2) unstable; urgency=medium

  * Skip test that depends on DNS setup

 -- James Valleroy <jvalleroy@mailbox.org>  Sat, 15 Jan 2022 10:07:12 -0500

shaarli (0.12.1+dfsg-1) unstable; urgency=medium

  * d/README.source: Checkout upstream before merge
  * New upstream version 0.12.1+dfsg
  * Update patches for v0.12.1
  * Build-Depend on php-malkusch-lock
  * Build-Depend on php-parsedown-extra
  * Skip more tests that require Internet access
  * Add override for php-klogger
  * Skip additional tests due to root user
  * Skip tests that depend on working directory
  * Build-Depend on node-he
  * Don't ignore errors when running webpack
  * Move history into /var/lib/shaarli
  * Specify locale when running tests
  * Skip testReadNotReadable test

 -- James Valleroy <jvalleroy@mailbox.org>  Fri, 07 Jan 2022 12:08:25 -0500

shaarli (0.12.0+dfsg-4) unstable; urgency=medium

  * Fix doc build using upstream patch (Closes: #997328)
  * d/control: Set standards version to 4.6.0

 -- James Valleroy <jvalleroy@mailbox.org>  Sat, 06 Nov 2021 12:16:57 -0400

## shaarli 0.12.1+dfsg

=== Makefile ===
--- 
+++ 
@@ -26,10 +26,6 @@
 
 code_sniffer:
 	@$(PHPCS)
-
-### - errors filtered by coding standard: PEAR, PSR1, PSR2, Zend...
-PHPCS_%:
-	@$(PHPCS) --report-full --report-width=200 --standard=$*
 
 ### - errors by Git author
 code_sniffer_blame:
@@ -175,6 +171,7 @@
 eslint:
 	@yarn run eslint -c .dev/.eslintrc.js assets/vintage/js/
 	@yarn run eslint -c .dev/.eslintrc.js assets/default/js/
+	@yarn run eslint -c .dev/.eslintrc.js assets/common/js/
 
 ### Run CSSLint check against Shaarli's SCSS files
 sasslint:

=== debian/control ===
--- 
+++ 
@@ -13,17 +13,20 @@
                node-babel-loader,
                node-css-loader,
                node-file-loader,
+               node-he,
                node-mini-css-extract-plugin,
-               node-uglifyjs-webpack-plugin,
+               node-terser-webpack-plugin,
                php-arthurhoaro-web-thumbnailer,
                php-curl,
                php-gd,
                php-intl,
                php-ldap,
+               php-malkusch-lock,
                php-mbstring,
                php-netscape-bookmark-parser,
                php-oscarotero-gettext,
                php-parsedown,
+               php-parsedown-extra,
                php-pubsubhubbub-publisher,
                php-slim,
                phpab,
@@ -32,7 +35,7 @@
                ruby-sass,
                sass-stylesheets-purecss,
                webpack
-Standards-Version: 4.5.1
+Standards-Version: 4.6.1
 Homepage: https://github.com/shaarli/Shaarli
 Vcs-Browser: https://salsa.debian.org/php-team/pear/shaarli
 Vcs-Git: https://salsa.debian.org/php-team/pear/shaarli.git

=== debian/rules ===
--- 
+++ 
@@ -18,5 +18,4 @@
 	make htmldoc
 	mkdir --parents assets/default/css
 	sass assets/default/scss/shaarli.scss > assets/default/css/shaarli.css
-	# Ignore errors due to missing dependencies.
-	webpack || true
+	webpack

=== debian/tests/control ===
Tests: upstream-tests
Depends: phpab, phpunit, sudo, @
Restrictions: needs-root

Tests: apache-test
Depends: apache2, sudo, wget, @
Restrictions: needs-root

=== debian/watch ===
version=4
opts="mode=git, gitmode=full, pgpmode=gittag, dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$//" \
https://github.com/shaarli/Shaarli.git \
refs/tags/v([\d\.]+) debian uupdate

## shaarli 0.13.0%2Bdfsg

=== debian/changelog ===
shaarli (0.13.0+dfsg-2) unstable; urgency=medium

  * postinst: Enable apache rewrite module (Closes: #1032919)
  * tests: Check install page messages
  * Remove compiling message for blhc
  * links: Link forkawesome fonts into assets folder
  * Update copyright year

 -- James Valleroy <jvalleroy@mailbox.org>  Fri, 09 Feb 2024 16:16:03 -0500

shaarli (0.13.0+dfsg-1) unstable; urgency=medium

  * New upstream version 0.13.0+dfsg (Closes: #1043259)
  * Refresh patches
  * Add build-deps for sphinx document generation
  * Apply upstream patch for PHP 8.x intl incompatibility
  * Add dependency on php-klogger
  * Remove obsolete patches
  * d/clean: Specify css directory
  * Remove .doctrees folder after building docs
  * Re-number patches
  * Drop fonts that are packaged separately
  * Depend on fonts-fork-awesome (Closes: #1040575)
  * Links to packaged Roboto fonts
  * Link to packaged sphinx JS files
  * Set standards version to 4.6.2
  * Update d/copyright
  * Minify qrcode JS during build (Closes: #1032920)

 -- James Valleroy <jvalleroy@mailbox.org>  Fri, 15 Dec 2023 11:46:30 -0500

## shaarli 0.13.0+dfsg

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# The personal, minimalist, super-fast, database free, bookmarking service.
+# The personal, minimalist, super fast, database-free, bookmarking service.
 # Makefile for PHP code analysis & testing, documentation and release generation
 
 BIN = vendor/bin
@@ -23,6 +23,13 @@
 # - http://pear.php.net/manual/en/package.php.php-codesniffer.reporting.php
 ##
 PHPCS := $(BIN)/phpcs
+
+# Use GNU Tar where available
+ifneq (, $(shell which gtar))
+TAR := gtar
+else
+TAR := tar
+endif
 
 code_sniffer:
 	@$(PHPCS)
@@ -106,18 +113,18 @@
 
 ### download 3rd-party frontend libraries
 frontend_dependencies:
-	yarn install
+	yarnpkg install
 
 ### Build frontend dependencies
 build_frontend: frontend_dependencies
-	yarn run build
+	yarnpkg run build
 
 ### generate a release tarball and include 3rd-party dependencies and translations
 release_tar: composer_dependencies htmldoc translate build_frontend
 	git archive --prefix=$(ARCHIVE_PREFIX) -o $(ARCHIVE_VERSION).tar HEAD
-	tar rvf $(ARCHIVE_VERSION).tar --transform "s|^vendor|$(ARCHIVE_PREFIX)vendor|" vendor/
-	tar rvf $(ARCHIVE_VERSION).tar --transform "s|^doc/html|$(ARCHIVE_PREFIX)doc/html|" doc/html/
-	tar rvf $(ARCHIVE_VERSION).tar --transform "s|^tpl|$(ARCHIVE_PREFIX)tpl|" tpl/
+	$(TAR) rvf $(ARCHIVE_VERSION).tar --transform "s|^vendor|$(ARCHIVE_PREFIX)vendor|" vendor/
+	$(TAR) rvf $(ARCHIVE_VERSION).tar --transform "s|^doc/html|$(ARCHIVE_PREFIX)doc/html|" doc/html/
+	$(TAR) rvf $(ARCHIVE_VERSION).tar --transform "s|^tpl|$(ARCHIVE_PREFIX)tpl|" tpl/
 	gzip $(ARCHIVE_VERSION).tar
 
 ### generate a release zip and include 3rd-party dependencies and translations
@@ -140,10 +147,10 @@
 ### remove all unversioned files
 clean:
 	@git clean -df
-	@rm -rf sandbox
+	@rm -rf sandbox trivy*
 
 ### generate the AUTHORS file from Git commit information
-authors:
+generate_authors:
 	@cp .github/mailmap .mailmap
 	@git shortlog -sne > AUTHORS
 	@rm .mailmap
@@ -152,27 +159,57 @@
 phpdoc: clean
 	@docker run --rm -v $(PWD):/data -u `id -u`:`id -g` phpdoc/phpdoc
 
-### generate HTML documentation from Markdown pages with MkDocs
+### generate HTML documentation from Markdown pages with Sphinx
 htmldoc:
 	python3 -m venv venv/
 	bash -c 'source venv/bin/activate; \
 	pip install wheel; \
-	pip install mkdocs; \
-	mkdocs build --clean'
+	pip install sphinx==7.1.0 furo==2023.7.26 myst-parser sphinx-design; \
+	sphinx-build -b html -c doc/ doc/md/ doc/html/'
 	find doc/html/ -type f -exec chmod a-x '{}' \;
 	rm -r venv
 
-
 ### Generate Shaarli's translation compiled file (.mo)
 translate:
-	@find inc/languages/ -name shaarli.po -execdir msgfmt shaarli.po -o shaarli.mo \;
+	@echo "----------------------"
+	@echo "Compile translation files"
+	@echo "----------------------"
+	@for pofile in `find inc/languages/ -name shaarli.po`; do \
+		echo "Compiling $$pofile"; \
+		msgfmt -v "$$pofile" -o "`dirname "$$pofile"`/`basename "$$pofile" .po`.mo"; \
+	done;
 
 ### Run ESLint check against Shaarli's JS files
 eslint:
-	@yarn run eslint -c .dev/.eslintrc.js assets/vintage/js/
-	@yarn run eslint -c .dev/.eslintrc.js assets/default/js/
-	@yarn run eslint -c .dev/.eslintrc.js assets/common/js/
+	@yarnpkg run eslint -c .dev/.eslintrc.js assets/vintage/js/
+	@yarnpkg run eslint -c .dev/.eslintrc.js assets/default/js/
+	@yarnpkg run eslint -c .dev/.eslintrc.js assets/common/js/
 
 ### Run CSSLint check against Shaarli's SCSS files
 sasslint:
-	@yarn run stylelint --config .dev/.stylelintrc.js 'assets/default/scss/*.scss'
+	@yarnpkg run stylelint --config .dev/.stylelintrc.js 'assets/default/scss/*.scss'
+
+##
+# Security scans
+##
+
+# trivy version (https://github.com/aquasecurity/trivy/releases)
+TRIVY_VERSION=0.44.0
+# default trivy exit code when vulnerabilities are found
+TRIVY_EXIT_CODE=1
+# default docker image to scan with trivy
+TRIVY_TARGET_DOCKER_IMAGE=ghcr.io/shaarli/shaarli:latest
+
+### download trivy vulneravbility scanner
+download_trivy:
+	wget --quiet --continue -O trivy_$(TRIVY_VERSION)_Linux-64bit.tar.gz https://github.com/aquasecurity/trivy/releases/download/v$(TRIVY_VERSION)/trivy_$(TRIVY_VERSION)_Linux-64bit.tar.gz
+	tar -z -x trivy -f trivy_$(TRIVY_VERSION)_Linux-64bit.tar.gz
+
+### run trivy vulnerability scanner on docker image
+test_trivy_docker: download_trivy
+	./trivy --exit-code $(TRIVY_EXIT_CODE) image $(TRIVY_TARGET_DOCKER_IMAGE)
+
+### run trivy vulnerability scanner on composer/yarn dependency trees
+test_trivy_repo: download_trivy
+	./trivy --exit-code $(TRIVY_EXIT_CODE) fs composer.lock
+	./trivy --exit-code $(TRIVY_EXIT_CODE) fs yarn.lock

=== debian/changelog ===
shaarli (0.13.0+dfsg-5) unstable; urgency=medium

  * Team upload
  * Modernize PHPUnit syntax

 -- David Prévot <taffit@debian.org>  Fri, 21 Mar 2025 15:32:20 +0100

shaarli (0.13.0+dfsg-4) unstable; urgency=medium

  * Team upload

  [ James Valleroy ]
  * Clean sass cache and qrcode
  * Make test providers static

  [ David Prévot ]
  * Group nophpunit11 for test failing with PHPUnit 11 (Closes: #1039855)
  * Rename PluginQrcodeTest as PluginReadItLaterTest (PHPUnit 11 fix)

 -- David Prévot <taffit@debian.org>  Wed, 15 Jan 2025 10:45:56 +0100

shaarli (0.13.0+dfsg-3) unstable; urgency=medium

  * Team upload
  * Force system dependencies loading

 -- David Prévot <taffit@debian.org>  Thu, 07 Mar 2024 17:48:27 +0100

=== debian/control ===
--- 
+++ 
@@ -6,10 +6,10 @@
 Build-Depends: apache2-dev,
                debhelper-compat (= 13),
                fonts-fork-awesome,
+               furo,
                gettext,
                libjs-awesomplete,
                libjs-blazy,
-               mkdocs,
                node-babel-loader,
                node-css-loader,
                node-file-loader,
@@ -20,6 +20,7 @@
                php-curl,
                php-gd,
                php-intl,
+               php-klogger,
                php-ldap,
                php-malkusch-lock,
                php-mbstring,
@@ -32,10 +33,14 @@
                phpab,
                phpunit,
                pkg-php-tools,
+               python3-myst-parser,
+               python3-sphinx,
+               python3-sphinx-design,
                ruby-sass,
                sass-stylesheets-purecss,
+               uglifyjs,
                webpack
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/shaarli/Shaarli
 Vcs-Browser: https://salsa.debian.org/php-team/pear/shaarli
 Vcs-Git: https://salsa.debian.org/php-team/pear/shaarli.git
@@ -43,7 +48,9 @@
 
 Package: shaarli
 Architecture: all
-Depends: gettext,
+Depends: fonts-fork-awesome,
+         fonts-roboto-fontface,
+         gettext,
          javascript-common,
          libapache2-mod-php | php-cgi | php-fpm | php,
          libjs-jquery,
@@ -52,8 +59,10 @@
          php-curl,
          php-gd,
          php-intl,
+         php-klogger,
          php-ldap,
          php-mbstring,
+         sphinx-doc,
          ${misc:Depends},
          ${phpcomposer:Debian-require}
 Recommends: apache2 | httpd, ${misc:Recommends}

## shaarli 0.14.0+dfsg

=== Makefile ===
--- 
+++ 
@@ -194,11 +194,13 @@
 ##
 
 # trivy version (https://github.com/aquasecurity/trivy/releases)
-TRIVY_VERSION=0.44.0
+TRIVY_VERSION=0.56.2
 # default trivy exit code when vulnerabilities are found
 TRIVY_EXIT_CODE=1
 # default docker image to scan with trivy
 TRIVY_TARGET_DOCKER_IMAGE=ghcr.io/shaarli/shaarli:latest
+# branch on which test_trivy_repo should be run. leave undefined for the current branch
+#TRIVY_TARGET_BRANCH=origin/release
 
 ### download trivy vulneravbility scanner
 download_trivy:
@@ -211,5 +213,9 @@
 
 ### run trivy vulnerability scanner on composer/yarn dependency trees
 test_trivy_repo: download_trivy
+ifdef TRIVY_TARGET_BRANCH
+	git checkout $(TRIVY_TARGET_BRANCH) composer.lock
+	git checkout $(TRIVY_TARGET_BRANCH) yarn.lock
+endif
 	./trivy --exit-code $(TRIVY_EXIT_CODE) fs composer.lock
 	./trivy --exit-code $(TRIVY_EXIT_CODE) fs yarn.lock

=== doc/requirements.txt ===
sphinx==7.1.0
furo==2023.7.26
myst-parser
sphinx-design

=== debian/changelog ===
shaarli (0.14.0+dfsg-2) trixie; urgency=medium

  * Add patch to fix CVE-2025-55291 (Closes: #1111589)

 -- James Valleroy <jvalleroy@mailbox.org>  Sat, 30 Aug 2025 07:45:06 -0400

shaarli (0.14.0+dfsg-1) unstable; urgency=medium

  [ William Desportes ]
  * New upstream version 0.14.0
  * Import the GPG key of nodiscc from GitHub
  * d/watch: Import all and filter out .git*
  * Remove the Roboto-* fonts from the source tarballs
  * Refresh patches
  * Bump Standards-Version to 4.7.2
  * Mark "Multi-Arch: foreign"

  [ James Valleroy ]
  * Add +dfsg to upstream version

 -- James Valleroy <jvalleroy@mailbox.org>  Tue, 15 Apr 2025 14:31:42 -0400

=== debian/control ===
--- 
+++ 
@@ -40,7 +40,7 @@
                sass-stylesheets-purecss,
                uglifyjs,
                webpack
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Homepage: https://github.com/shaarli/Shaarli
 Vcs-Browser: https://salsa.debian.org/php-team/pear/shaarli
 Vcs-Git: https://salsa.debian.org/php-team/pear/shaarli.git
@@ -48,6 +48,7 @@
 
 Package: shaarli
 Architecture: all
+Multi-Arch: foreign
 Depends: fonts-fork-awesome,
          fonts-roboto-fontface,
          gettext,

=== debian/watch ===
version=4
opts="mode=git, gitexport=all, pgpmode=gittag, dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$//" \
https://github.com/shaarli/Shaarli.git \
refs/tags/v([\d\.]+) debian uupdate

## shaarli 0.15.0%2Bdfsg

=== debian/tests/control ===
Tests: upstream-tests
Depends: phpab, phpunit (>= 11), sudo, @
Restrictions: needs-root

Tests: apache-test
Depends: apache2, sudo, wget, @
Restrictions: needs-root

## shaarli 0.15.0+dfsg

=== Makefile ===
--- 
+++ 
@@ -76,17 +76,13 @@
 	@$(BIN)/phpunit --coverage-php coverage/main.cov --bootstrap tests/bootstrap.php --testsuite unit-tests
 
 locale_test_%:
-	@UT_LOCALE=$*.utf8 \
+	@LANG=$*.utf8 \
 		$(BIN)/phpunit \
 		--coverage-php coverage/$(firstword $(subst _, ,$*)).cov \
 		--bootstrap tests/languages/bootstrap.php \
 		--testsuite language-$(firstword $(subst _, ,$*))
 
 all_tests: test locale_test_de_DE locale_test_en_US locale_test_fr_FR
-	@# --The current version is not compatible with PHP 7.2
-	@#$(BIN)/phpcov merge --html coverage coverage
-	@# --text doesn't work with phpunit 4.* (v5 requires PHP 5.6)
-	@#$(BIN)/phpcov merge --text coverage/txt coverage
 
 ### download 3rd-party PHP libraries, including dev dependencies
 composer_dependencies_dev: clean

=== debian/changelog ===
shaarli (0.15.0+dfsg-1) unstable; urgency=high

  * New upstream version 0.15.0 (Closes: #1111589, CVE-2025-55291)
  * Update patches

 -- James Valleroy <jvalleroy@mailbox.org>  Fri, 22 Aug 2025 07:20:50 -0400

=== debian/rules ===
--- 
+++ 
@@ -16,6 +16,12 @@
 		*.php application tests plugins
 	make translate
 	make htmldoc
+	rm \
+		doc/html/_static/doctools.js \
+		doc/html/_static/language_data.js \
+		doc/html/_static/searchtools.js \
+		doc/html/_static/sphinx_highlight.js
 	mkdir --parents assets/default/css
 	sass assets/default/scss/shaarli.scss > assets/default/css/shaarli.css
 	webpack
+	uglifyjs plugins/qrcode/qr-1.1.3.js > plugins/qrcode/qr-1.1.3.min.js

## shaarli 0.16.1+dfsg

=== Makefile ===
--- 
+++ 
@@ -136,6 +136,20 @@
 	zip -r $(ARCHIVE_VERSION).zip $(ARCHIVE_PREFIX)tpl/
 	rm -rf $(ARCHIVE_PREFIX)
 
+### bump version number in all relevant files
+bump_version:
+ifndef VERSION
+	$(error VERSION is not set. Usage: make bump_version VERSION=x.y.z)
+endif
+	@echo "Bumping version to $(VERSION)..."
+	@sed -i 's|/\* .* \*/|/* $(VERSION) */|' shaarli_version.php
+	@sed -i "s/^version = '.*'/version = '$(VERSION)'/" doc/conf.py
+	@sed -i "s/^release = '.*'/release = '$(VERSION)'/" doc/conf.py
+	@sed -i "s|/badge/release-v[^-]*-|/badge/release-v$(VERSION)-|" README.md
+	@sed -i "s|/releases/tag/v[0-9.]*|/releases/tag/v$(VERSION)|" README.md
+	@echo "Version bumped to $(VERSION)"
+	@echo "Please review the changes with 'git diff' before committing."
+
 ##
 # Targets for repository and documentation maintenance
 ##

=== debian/changelog ===
shaarli (0.16.1+dfsg-1) unstable; urgency=medium

  * Change debian branch name to debian/latest
  * Update debian/watch to Version 5
  * signing-key: Concatenate blocks, as instructed by uscan
  * d/control: Remove options that are now default
  * d/copyright: Update copyright year for debian/*
  * d/clean: Clean up generated files (Closes: #1048094)
  * d/postinst: Only enable apache mod rewrite if not already enabled
    (Closes: #1116936)
  * d/watch: Add Repacksuffix
  * d/copyright: Drop jquery excluded file, no longer shipped upstream
  * New upstream version 0.16.1+dfsg (Closes: #1126554, CVE-2026-24476)

 -- James Valleroy <jvalleroy@mailbox.org>  Sat, 31 Jan 2026 09:33:15 -0500

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: shaarli
 Section: web
-Priority: optional
 Maintainer: Debian PHP PEAR Maintainers <pkg-php-pear@lists.alioth.debian.org>
 Uploaders: James Valleroy <jvalleroy@mailbox.org>
 Build-Depends: apache2-dev,
@@ -44,7 +43,6 @@
 Homepage: https://github.com/shaarli/Shaarli
 Vcs-Browser: https://salsa.debian.org/php-team/pear/shaarli
 Vcs-Git: https://salsa.debian.org/php-team/pear/shaarli.git
-Rules-Requires-Root: no
 
 Package: shaarli
 Architecture: all

=== debian/watch ===
Version: 5

Source: https://github.com/shaarli/Shaarli.git
Matching-Pattern: refs/tags/v([\d\.]+)
Dversionmangle: s/\+(debian|dfsg|ds|deb)(\.?\d+)?$//
Repacksuffix: +dfsg
Gitexport: all
Mode: git
Pgpmode: gittag
Update-Script: uupdate
